# Commandline Application - 4ss_manager

#### 4Suite repository management tools

> This command-line application allows a 4Suite repository administrator to perform management tasks on the repository as a whole, including setup, server control, backup, and other operations.

## Usage

    4ss_manager
    [--help] [--show-commands]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
--show-commands | show system command tree

## Sub Commands

Command | Description
--- | ---
4ss_manager backup | Create a low level backup of the entire system.
4ss_manager init | Initialize the 4Suite repository
4ss_manager log | Commands to work with the logs
4ss_manager recompile | Recompile all stylesheets
4ss_manager restart | Restart the 4Suite server (controller)
4ss_manager start | Start the 4Suite server (controller)
4ss_manager status | Report on the state of a repository and its servers
4ss_manager stop | Stop the 4Suite server (controller)

# Command - 4ss_manager status

#### Report on the state of a repository and its servers

> This command lists the status of each server in a 4Suite repository (running or stopped) as well as the state of the repository itself (data store existence and initialization status).

## Usage

    4ss_manager status
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file

# Command - 4ss_manager log

#### Commands to work with the logs

> Manager commands to work with the log files

## Usage

    4ss_manager log
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file

## Sub Commands

Command | Description
--- | ---
4ss_manager log clear | Clear a 4SS Log
4ss_manager log view | View a 4SS Log

# Command - 4ss_manager log clear

#### Clear a 4SS Log

> Clear the logs

## Usage

    4ss_manager log clear
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file

# Command - 4ss_manager log view

#### View a 4SS Log

> View the logs

## Usage

    4ss_manager log view
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>] [--bytes=<N>]
    [--lines=<N>] [--sleep-interval=<S>]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file
-c, --bytes=<N> | output the last N bytes
-n, --lines=<N> | output the last N lines, instead of the last 10
-s, --sleep-interval=<S> | sleep for approximately S seconds (default 1.0) between iterations

# Command - 4ss_manager recompile

#### Recompile all stylesheets

> The recompile command will walk the entire repository and recompile all stylesheets. It is useful when changes to the underling code base require that stylesheets be reinited in the system.

## Usage

    4ss_manager recompile
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>] [path]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file

## Arguments

Name | Description
--- | ---
path | The root path for the operation. Only resources within this path will get recompiled.

# Command - 4ss_manager stop

#### Stop the 4Suite server (controller)

> The stop command is used to stop any or all of the 4SS servers. To stop all the servers, execute the stop command with out any arguments. To stop an individual server, specify their names as command line arguments. You will be prompted for authentication before you can stop the servers.

## Usage

    4ss_manager stop
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>] [server-uri]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file

## Arguments

Name | Description
--- | ---
server-uri | If specified, set the running state of this server to 'off'. This does not stop the 4ss daemon

# Command - 4ss_manager start

#### Start the 4Suite server (controller)

> The start command can be used to start any or all protocol servers. To start all of the servers, execute the start command with no paramters. To bring up individual servers, list them on the command line.

## Usage

    4ss_manager start
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>] [--no-daemon]
    [server-uri]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file
-n, --no-daemon | Do not detach from the terminal

## Arguments

Name | Description
--- | ---
server-uri | If specified, set the running state of this server to 'on'. This does not start the 4ss daemon

# Command - 4ss_manager init

#### Initialize the 4Suite repository

> Initialize the repository. This involves reformatting the storage back end (e.g. Postgres database or FlatFile root directory) and then adding the core data structures. You will LOSE ALL DATA when you execute the init, unless you use the --update option. You can only init on the machine on which the command is executed. You must have write access to where the back end stores its data (e.g., your userid must be able to write to the Postgres database if the back end is Postgres). You may be prompted for additional information to complete the init.

## Usage

    4ss_manager init
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>] [--confirm]
    [--update] [--repo-only] [components]...

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file
-c, --confirm | Confirm before performing each sub-task.
-r, --update | Don't destroy the current repository, just update the data.
-o, --repo-only | Only create the bare repository (destroying any current one), and don't install any components. Only useful for development.

## Arguments

Name | Description
--- | ---
components | Specify which components to add/update in the repository. Allowed values are: 'Commands' - 4ss and 4ss_manager commands and documentation; these are needed to be able to use the 4ss and 4ss_manager command-line tools; 'Docs' - All 4Suite documentation; 'Servers' - The default FtRpc and Ftp Server; 'Demos' - The default 4Suite Repository Demonstration applications and the server to access them; 'Dashboard' - The web-based control panel for 4Suite; 'Data' - Commonly used 4Suite data and icons (required; must be first component installed).

# Command - 4ss_manager backup

#### Create a low level backup of the entire system.

> Create a low level system backup of the entire repository

## Usage

    4ss_manager backup
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>]
    [--exclude=<exclude>] [--directory=<directory>]
    [--modified-since=<modified-since>] [--quiet] [--user-model]
    [--archive=[gztar|ztar|bztar|zip|tar]] [base-path]...

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file
-e, --exclude=<exclude> | Exclude a path (and all children) from backup (multiple allowed)
-d, --directory=<directory> | Directory to backup too.
-m, --modified-since=<modified-since> | Only backup files modified since specified ISO datetime
-q, --quiet | No extra output
--user-model | Also dump the user model
--archive=[gztar|ztar|bztar|zip|tar] | Create an archive (not all options will work on all platforms!!) Allowed Values:
gztar | gzip'ed tar-file
ztar | compressed tar file
bztar | bzip2'ed tar-file
zip | ZIP file
tar | uncompressed tar file

## Arguments

Name | Description
--- | ---
base-path | Initial resources to start the backup at.

# Command - 4ss_manager restart

#### Restart the 4Suite server (controller)

> Restart the 4Suite server (controller).

## Usage

    4ss_manager restart
    [--help] [--username=<USER>] [--password=<PASSWORD>]
    [--core-id=<CORE>] [--config-file=<FILEPATH>]

## Options

Name | Description
--- | ---
-h, --help | show detailed help message
-u, --username=<USER> | authenticate using the given user name
-p, --password=<PASSWORD> | authenticate using the given password
-I, --core-id=<CORE> | use a specific core in config file (default: Core)
-C, --config-file=<FILEPATH> | use alternative repository configuration file